﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.Domain
@{
    ViewData["Title"] = "Index";
}
<script src="~/Script/Master/Layout.js"></script>

@if (!string.IsNullOrEmpty(TempData["success"]?.ToString()))
{
    <script>
        toastr.success('@TempData["success"]');
    </script>
}
else if (!string.IsNullOrEmpty(TempData["error"]?.ToString()))
{
    <script>
        toastr.error('@TempData["error"]');
    </script>
}

<style>
    .backtolist {
        margin-top: 3px !important;
    }

    .addbtn .add_litigation {
        margin-bottom: 15px;
    }

    .domaincls {
        height: calc(100vh - 262px);
        padding: 0px 12px 15px;
        background: #f8f8f8;
        overflow-y: auto;
    }

        .domaincls .table_control {
            margin-top: 12px;
        }

    tr td:first-child {
        text-align: left !important;
    }
    .orgmap li span.text.active {
        background-color: #915799;
    }
    
</style>
<script>
    //$(document).ready(function () {
    //    BackButton();
    //    if ($("#ID").val() > 0) {
    //        $(".titile_heading h1").html("Edit Sub Domain");
    //        $(".service_line").addClass("active");
    //        $(".assign_panel").hide();
    //        $(".titile_heading").show();
    //        $("#viewbutton").show();
    //        $("#domainModal").modal("show");
    //    }
    //    else {
    //        $(".service_line").removeClass("active");
    //        $(".assign_panel").show();
    //        $(".titile_heading").show();
    //        $("#viewbutton").show();
    //    }

    //    $(".form-control").focusout(function () {
    //        if ($(this).val() != "") {
    //            $(this).removeClass("clsDanger");
    //            $("#msg").hide();
    //        }
    //    });
    //});
    function fn_GetDomainNameAdd() {
        $('#DomaintypeId').val('');
        $('#Domaintype').val('');
        $('#DomainCodes').val('');
    }

    function fn_GetDomainName() {
        var DomailVal = $('#DomainId').val();
        $('#DomaintypeId').val('');
        $('#Domaintype').val('');
        $('#DomainCodes').val('');
        var DomailText = $('select#DomainId option:selected').text();
        if (DomailVal > 0) {
            $.ajax({
                url: "/Master/Domain/GetDomainID",
                type: "POST",
                cache: false,
                data: { ID: $("select#DomainId option:selected").val() },
                success: function (result) {
                    debugger
                    // $("input[name=DomainCode]").val(result[0].domainCode + "-");
                    $('#DomaintypeId').val(result[0].id);
                    $('#Domaintype').val(result[0].domainName);
                    $('#DomainCodes').val(result[0].domainCode);
                }, error: function (ex) {
                    console.log(ex.statusText);
                }
            })
        }
    }

    function AddButton() {
        $(".titile_heading h1").html("Add Sub Domain");
        $(".service_line").addClass("active");
        $(".assign_panel").hide();
        $(".titile_heading").show();
        $("#viewbutton").show();
        $("#DomainId").val('');
        $("#SubDomain").val('');
        $("#Code").val('');
        $("#DomainCode").val('');
        $(".backtolist").hide();

    }
    function BackButton() {
        $(".titile_heading h1").html("Sub Domain List");
        $(".service_line").removeClass("active");
        $(".assign_panel").show();
        $(".titile_heading").show();
        $("#viewbutton").show();
        $(".backtolist").show();
    }
    function CheckValidation() {

        var errorSts = 0;
        var checkval_ServiceName = $("#DomainId").val();
        if (checkval_ServiceName == "") {
            $("#DomainId").addClass('clsDanger').focus();
            errorSts++;
        }
        var checkval_ShortName = $("#SubDomain").val();
        if (checkval_ShortName == "") {
            $("#SubDomain").addClass('clsDanger').focus();
            errorSts++;
        }

        if (errorSts > 0) {
            return false;
        }
        else {
        }
    }
    function fn_SubDomain(Id, input) {
        $(".orgmap li span.text").removeClass("active");        $(input).addClass("active");
        $.ajax({
            url: "/Master/Domain/GetSubDomainByDomain",
            type: "POST",
            data: { DomainId: Id },
            success: function (result) {
                $("#tblDomain tbody").empty();
                if (result.length > 0) {
                    for (var i = 0; i < result.length; i++) {
                        $("#tblDomain tbody").append(
                            "<tr><td>" + result[i].subDomain + "</td><td>" + result[i].code + "</td>" +
                            "<td><a onclick='fn_EditDomain(" + result[i].id + ")' class='edit_btn' ></a > <a class='delete_btn' onclick = 'Confirmation(" + result[i].id + ",this)' ></a ></td ></tr > "
                        );
                    }
                } else {
                    $("#tblDomain tbody").append("<tr><td colspan='5' class='text-center'></td></tr>");
                }
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        })
    }
    function fn_EditDomain(ID) {
        $.get('/Master/Domain/Index', { id: ID }, function (res) {
            $("#ajaxresult").html(res);
        })
    }

</script>

<section>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Sub Domain List</h1>
            <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="TabMenu" asp-controller="Domain" asp-area="Master">Back to Menu</a>
            <div class="titile_line"></div>
        </div>
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="service_line">
                        <form role="form" asp-action="SaveupdateDomain" asp-controller="Domain" asp-area="Master"
                              data-ajax="true"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading......"
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'Master/Domain/Index');"
                              data-ajax-failure="Errmsg(data);">
                            <div asp-validation-summary="All" class="text-danger"></div>
                            @Html.HiddenFor(m => m.Id)
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Control Domain</label>
                                    <div class="select_box m_bottom">
                                        <select asp-for="DomainId" asp-items="@Model.DDlDomain" class="form-control" value="@Model.DomainId">
                                            <option value="">--select--</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-2 col-sm-2 col-xs-6" style="margin-top:38px">
                                    <div class="select_box m_bottom">
                                        <button class="btn btn-info" type="button" data-toggle="modal" data-target="#domainModal"><i class="fa fa-plus" aria-hidden="true"></i></button>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Sub Domain</label>
                                    <div class="select_box m_bottom">
                                        @Html.TextBoxFor(m => m.SubDomain, new { @class = "form-control", placeholder = "Enter sub domain" })
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Sub Domain code</label>
                                    <div class="select_box m_bottom">
                                        <div class="col-xs-3">
                                            <input class="form-control-plaintext" asp-for="DomainCode" readonly />
                                        </div>
                                        <div class="col-xs-9">
                                            <input asp-for="Code" placeholder="Enter code" class="form-control" value="@Model.Code" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-12 col-sm-6 col-xs-12">
                                    <div class="back_btn" id="viewbutton">
                                        <div class="back_btn_in" data-title="Back">
                                            <input type="button" name="Back" onclick="BackButton()" value="Back">
                                        </div>
                                    </div>
                                    <div class="submitbtn">
                                        <input type="submit" id="btnsubmit" name="Submit" value="Submit" onclick="CheckValidation()">
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="assign_panel">
                        <div class="col-lg-12 col-md-8 col-sm-8 col-xs-8">
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12"></div>
                                <div class="col-md-8 col-sm-6 col-xs-12">
                                    <div class="addbtn">
                                        <div class="add_litigation">
                                            <span>+</span>
                                            <input type="button" name="Add Sub Domain" onclick="AddButton()" value="Add Sub Domain">
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="row" id="MainDiv">
                                <div class="col-md-4 col-sm-12 col-xs-12">
                                    <div class="domaincls">
                                        <ul class="orgmap">
                                            @foreach (var item in Model.Domainlist)
                                            {
                                                <li class="first inactive">
                                                    <div>
                                                        <span class="text Event" onclick="fn_SubDomain('@item.Id',this)">@item.DomainName</span>
                                                    </div>
                                                </li>
                                            }
                                        </ul>
                                    </div>
                                </div>
                                <div class="col-md-8 col-sm-12 col-xs-12">
                                    <div class="domaincls">
                                        <div class="table_control">
                                            <table class="table" id="tblDomain">
                                                <thead>
                                                    <tr>
                                                        <th>Sub Domain</th>
                                                        <th>Code</th>
                                                        <th style="width: 130px">Action</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    <tr>
                                                        <td colspan="3" class="text-center">No record found...</td>
                                                    </tr>
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="modal" id="domainModalDetails" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true" data-backdrop="static" data-keyboard="false">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="exampleModalLabel">Add Domain Details</h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div>
                                <div class="modal-body">
                                </div>
                                <div class="modal-footer">
                                    <button class="btn btn-info" type="button" onclick="fn_GetDomainNameAdd()" data-toggle="modal" data-target="#domainModal">Add</button>
                                    <button class="btn btn-info" onclick="fn_GetDomainName()" type="button" data-toggle="modal" data-target="#domainModal">Update</button>
                                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="modal" id="domainModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true" data-backdrop="static" data-keyboard="false">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="exampleModalLabel">Add Domain</h5>
                                </div>
                                <div class="modal-body">
                                    <div class="col-md-6">
                                        <label>Control Domain</label><span class="text-danger">*</span>
                                        <input class="form-control" id="DomaintypeId" style="display:none;" />
                                        <input class="form-control" asp-for="Domaintype" placeholder="Enter domain name" />
                                    </div>
                                    <div class="col-md-6">
                                        <label>Control Domain Code</label><span class="text-danger">*</span>
                                        <input id="DomainCodes" class="form-control" placeholder="Enter domain code" />
                                    </div>
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                                    <button type="button" class="btn btn-primary" id="cBtn">Save</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<script>
    $(document).ready(function () {
        if ($("#Id").val() > 0) {
            $(".titile_heading h1").html("Add Domain");
            $(".backtolist").hide();
            $(".titile_heading h1").html("Add Sub Domain");
            $(".service_line").addClass("active");
            $(".assign_panel").hide();
            $(".titile_heading").show();
        } else {
            $(".titile_heading h1").html("Domain List");
            $(".backtolist").show();
            $(".titile_heading h1").html("Sub Domain List");
            $(".service_line").removeClass("active");
            $(".assign_panel").show();
            $(".titile_heading").show();
        }
    });
    function BindDomain() {
        $.ajax({
            url: "/Master/Domain/GetDomain",
            type: "POST",
            cache: false,
            success: function (list) {
                $('select[name=DomainId]').find('option:not(:first)').remove();
                for (var i = 0; i < list.length; i++) {
                    $('select[name=DomainId]').append("<option value=" + list[i].id + ">" + list[i].domainName + "</option>");
                }
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        });
    }
    var CheckCode, CheckSubDomain = "";
    function fn_Activeincative(id, status) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to ' + status + ' this domain',
            showCancelButton: true,
            confirmButtonText: status,
        }).then((result) => {
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/Master/Domain/BlockDeleteDomain",
                    type: "POST",
                    cache: false,
                    data: { Did: id, Type: Type = 0 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success(status + " " + "successfully!!");
                        $('a[href="/Master/Domain/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
    function Confirmation(id,input) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to delete this domain',
            showCancelButton: true,
            confirmButtonText: 'Delete',
        }).then((result) => {
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/Master/Domain/BlockDeleteDomain",
                    type: "POST",
                    cache: false,
                    data: { Did: id, Type: Type = 1 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success("Delete successfully!!");
                        $('a[href="/Master/Domain/Index"]').click();
                        $(input).parent().parent().remove();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            } else if (result.isDenied) {
                Swal.fire('Changes are not saved', '', 'info')
            }
        });
    }
    $("select#DomainId").change(function () {
        debugger
        $.ajax({
            url: "/Master/Domain/GetDomainID",
            type: "POST",
            cache: false,
            data: { ID: $("select#DomainId option:selected").val() },
            success: function (result) {
                debugger
                $("input[name=DomainCode]").val(result[0].domainCode + "-");
            }, error: function (ex) {
                console.log(ex.statusText);
            }
        })
    });
    $("input[name=SubDomain]").change(function () {
        $.ajax({
            url: "/Master/Domain/CheckSubDomain",
            type: "POST",
            cache: false,
            data: { SubDomain: $("input[name=SubDomain]").val() },
            success: function (result) {
                if (!result) {
                    CheckSubDomain = $("input[name=SubDomain]").val() + " " + "already exists.Please try again.";
                    toastr.error(CheckSubDomain);
                }
                else {
                    CheckSubDomain = "";
                }
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        });
    });
    $("input[name=Code]").change(function () {
        $.ajax({
            url: "/Master/Domain/CheckCode",
            type: "POST",
            cache: false,
            data: { Code: $("#DomainName").val() + $("input[name=Code]").val() },
            success: function (result) {
                if (!result) {
                    CheckCode = $("#DomainName").val() + $("input[name=Code]").val() + " " + "already exists.Please try again.";
                    toastr.error(CheckCode);
                } else {
                    CheckCode = "";
                }
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        });
    });
    $("input[type=submit]").click(function (event) {
        if ($("select[name=DomainId]").val() == 0) {
            event.preventDefault();
            toastr.error("Select domain");
        } else if ($("input[name=Code]").val() == "") {
            event.preventDefault();
            toastr.error("Code is required.");
        } else if ($("input[name=SubDomain]").val() == "") {
            event.preventDefault();
            toastr.error("Sub domain is required.");
        }
    });
    $("#cBtn").click(function () {
        debugger
        if ($("input[name=Domaintype]").val() == "" || name != "") {
            var vali = name != "" ? name : "Domain name required.";
            toastr.error(vali);
            return false;
        } else if ($("#DomainCodes").val() == "" || code != "") {
            var vali = code != "" ? code : "Domain code required.";
            toastr.error(vali);
            return false;
        } else {
            $.ajax({
                url: "/Master/Domain/DomainSave",
                type: "POST",
                cache: false,
                data: { Id: $("#DomaintypeId").val(), DomainName: $("input[name=Domaintype]").val(), DomainCode: $("#DomainCodes").val() },
                success: function (result) {
                    debugger
                    if (result.isSuccess) {
                        BindDomain();
                        $("input[name=Domaintype]").val("");
                        $("#DomainCodes").val("");
                        $("#domainModal").modal("hide");
                        $("#domainModalDetails").modal("hide");
                        toastr.success("Save domain successfully");
                    } else {
                        toastr.error("Something is wrong!!");
                    }
                },
                error: function (ex) {
                    console.log(ex.responseText);
                }
            });
        }
    });
    var name, code = "";
    $("input[name=Domaintype]").change(function (e) {
        $.ajax({
            url: "/Master/Domain/CheckDomain",
            type: "POST",
            cache: false,
            data: { DomainName: e.target.value },
            success: function (result) {
                if (result) {
                    name = "Domain nameitemmSubDomainDomainubDomainDomainubDomainDomainDomainDomainDomainmalready exists.";
                    toastr.error("Domain name already exists.");
                } else {
                    name = "";
                }
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        });
    });
    $("#DomainCodes").change(function (e) {
        $.ajax({
            url: "/Master/Domain/CheckDomainCode",
            type: "POST",
            cache: false,
            data: { DomainCode: e.target.value },
            success: function (result) {
                if (result) {
                    code = "Domain Code already exists.";
                    toastr.error("Domain Code already exists.");
                }
                else {
                    code = "";
                }
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        });
    });
</script>